<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAlarmMessageResult_V4 ArrayType
 * @subpackage Arrays
 */
class ArrayOfAlarmMessageResult_V4 extends AbstractStructArrayBase
{
    /**
     * The AlarmMessageResult_V4
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AlarmMessageResult_V4[]
     */
    public $AlarmMessageResult_V4;
    /**
     * Constructor method for ArrayOfAlarmMessageResult_V4
     * @uses ArrayOfAlarmMessageResult_V4::setAlarmMessageResult_V4()
     * @param \StructType\AlarmMessageResult_V4[] $alarmMessageResult_V4
     */
    public function __construct(array $alarmMessageResult_V4 = array())
    {
        $this
            ->setAlarmMessageResult_V4($alarmMessageResult_V4);
    }
    /**
     * Get AlarmMessageResult_V4 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AlarmMessageResult_V4[]|null
     */
    public function getAlarmMessageResult_V4()
    {
        return isset($this->AlarmMessageResult_V4) ? $this->AlarmMessageResult_V4 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAlarmMessageResult_V4 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAlarmMessageResult_V4 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAlarmMessageResult_V4ForArrayConstraintsFromSetAlarmMessageResult_V4(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAlarmMessageResult_V4AlarmMessageResult_V4Item) {
            // validation for constraint: itemType
            if (!$arrayOfAlarmMessageResult_V4AlarmMessageResult_V4Item instanceof \StructType\AlarmMessageResult_V4) {
                $invalidValues[] = is_object($arrayOfAlarmMessageResult_V4AlarmMessageResult_V4Item) ? get_class($arrayOfAlarmMessageResult_V4AlarmMessageResult_V4Item) : sprintf('%s(%s)', gettype($arrayOfAlarmMessageResult_V4AlarmMessageResult_V4Item), var_export($arrayOfAlarmMessageResult_V4AlarmMessageResult_V4Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AlarmMessageResult_V4 property can only contain items of type \StructType\AlarmMessageResult_V4, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AlarmMessageResult_V4 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AlarmMessageResult_V4[] $alarmMessageResult_V4
     * @return \ArrayType\ArrayOfAlarmMessageResult_V4
     */
    public function setAlarmMessageResult_V4(array $alarmMessageResult_V4 = array())
    {
        // validation for constraint: array
        if ('' !== ($alarmMessageResult_V4ArrayErrorMessage = self::validateAlarmMessageResult_V4ForArrayConstraintsFromSetAlarmMessageResult_V4($alarmMessageResult_V4))) {
            throw new \InvalidArgumentException($alarmMessageResult_V4ArrayErrorMessage, __LINE__);
        }
        if (is_null($alarmMessageResult_V4) || (is_array($alarmMessageResult_V4) && empty($alarmMessageResult_V4))) {
            unset($this->AlarmMessageResult_V4);
        } else {
            $this->AlarmMessageResult_V4 = $alarmMessageResult_V4;
        }
        return $this;
    }
    /**
     * Add item to AlarmMessageResult_V4 value
     * @throws \InvalidArgumentException
     * @param \StructType\AlarmMessageResult_V4 $item
     * @return \ArrayType\ArrayOfAlarmMessageResult_V4
     */
    public function addToAlarmMessageResult_V4(\StructType\AlarmMessageResult_V4 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AlarmMessageResult_V4) {
            throw new \InvalidArgumentException(sprintf('The AlarmMessageResult_V4 property can only contain items of type \StructType\AlarmMessageResult_V4, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AlarmMessageResult_V4[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AlarmMessageResult_V4|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AlarmMessageResult_V4|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AlarmMessageResult_V4|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AlarmMessageResult_V4|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AlarmMessageResult_V4|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AlarmMessageResult_V4
     */
    public function getAttributeName()
    {
        return 'AlarmMessageResult_V4';
    }
}
